#!/usr/bin/env python

header = [
"# Test for proper behavior of 1000 (time) trigger events.",
"# Do not use a loop cable (it will confuse things).",
"# For triggers 100-1099,  the following metronome down",
"# velocity should be TRIGGER_NUM % 100. This makes it easy to verify",
"# correctness (that,is, that each trigger is doing what is should): look",
"# at a number of metronome events through the entire output file and",
"# verify that the metronome velocity equals the preceding trigger",
"# number % 100 ('%' == MOD, i.e., 156->56), trigger number in 'Note #' column",
"# (A velocity of 0 is handled poorly, so map that to 100)",
"# ",
"# 1000 triggers (rather than 4000) is chosen because large numbers of",
"# time triggers can cause a delay at trial start (on my machine,",
"# 180 ms for 4000 triggers). See the reference manual for details.",
"# ",
"# If by any chance there's a bug that cycles at 100 that might be",
"# missed, but the real concern is a 256-cycle due to a char type",
" ",
"# NOTE: setting MSPB to 1 appears to overflow some Linux buffers, ",
"# causing an EAGAIN error. MSPB = 10 takes longer to run, but works.",
"METRON_ON               1",
"MSPB                    10",
"MET_CHAN                1",
"MET_NOTE                86",
"MET_VEL                 50",
"MET_LEN                 0",
" ",
"TRIGGER 2 M  1005 END_EXP 1",
]

for i in header:
	print i

metnum = 1
for i in range(100,1100):
        vel = i % 100
	if vel == 0:
		vel = 100
	print "TRIGGER  %d\tT  %d\tMET_VEL  %d" % (i, (metnum - 1) * 10 + 5, vel)
        metnum = metnum + 1



