#!/usr/bin/env python

header = [
"# Test for proper behavior of 4000 (keystroke) trigger events,",
"# based on the loop test (so: use a loop cable).",
"# For triggers 100-4099,  the next feedback down velocity should be",
"# TRIGGER_NUM % 100. This makes it easy to verify correctness (that",
"# is, that each trigger is doing what is should): look",
"# at a number of feedback events through the entire output file and",
"# verify that the feedback velocity equals the preceding trigger",
"# number % 100 ('%' == MOD, i.e., 156->56), trigger num in 'Note #' column.",
"# (A velocity of 0 is handled poorly, so map that to 100)",
"# ",
"# For keystroke triggers, the 'Note #' field in the output file is the",
"# user-supplied trigger ID (from the parameter file), while 'Vel'",
"# is the internal table index.",
"# ",
"# If by any chance there's a bug that cycles at 100 that might be",
"# missed, but the real concern is a 256-cycle due to a char type",
" ",
"METRON_ON               1",
"MSPB                    3",
"MET_CHAN                1",
"MET_NOTE                86",
"MET_VEL                 100",
"MET_LEN                 0",
" ",
" ",
"FEED_ON                 1",
"FEED_LEN                0",
"FEED_VEL                7",
"FEED_PMODE              2",
"FEED_VMODE              1",
"",
"TRIGGER 1 M  2 METRON_ON 0",
"TRIGGER 2 K  4005 END_EXP 1",
]

for i in header:
	print i

keynum = 1
for i in range(100,4100):
        vel = i % 100
	if vel == 0:
		vel = 100
	print "TRIGGER  %d\tK  %d\tFEED_VEL  %d" % (i, keynum, vel)
        keynum = keynum + 1

   


